
YELLOW = 6
BLACK = 0
CYAN = 3

CLS

COLOR YELLOW, BLACK
PRINT "             ͻ  "
PRINT "                                      "
PRINT "                                           "
PRINT "                                     "
PRINT "             ͼ  "
PRINT ""
PRINT "                                Version 2.0"
PRINT
PRINT "         By Dave Fallen / 524 Ranger Dr. S.E. / Olympia, WA  98503"
PRINT "              Placed in the public domain -- February 14, 1988"
PRINT "                            Updated May 25, 1989"
PRINT
PRINT "          This program blanks the code responsible for noise in"
PRINT "          many programs.  The program code OUT 61,AL (hex E6 61)"
PRINT "          is changed to NOP NOP (hex 90 90).  The program attempts"
PRINT "          to avoid changing DATA, or the use of port 61H to issue"
PRINT "          a keyboard clear signal.  Once the sound code is blanked,"
PRINT "          your program will run silently.  This program will NOT"
PRINT "          modify your original program, but will create a clone"
PRINT "          with the 'noise code' blanked.  Output will use the drive"
PRINT "          and file name of your choice or, if you prefer, to a"
PRINT "          computer-generated default file name on the default drive."
PRINT

C$ = COMMAND$

IF C$ = "" THEN
    COLOR CYAN, BLACK
    PRINT "          SYNTAX:  SILENCER [d:] filename [[d:]filename]"
    END
END IF

GOSUB PARSE.COMMAND

FIL$ = F$ + CHR$(0)

CALL EXIST(FIL$, FILEXISTS%)

IF NOT FILEXISTS% THEN
   COLOR CYAN, BLACK
   PRINT STRING$(24, 32);
   PRINT F$; " DOES NOT EXIST"
   END
END IF

IF S$ = "" THEN
   S$ = F$

   D$ = "X:"
   CALL GETDRV(D$) 'default drive

  P = INSTR(S$, ":")

  IF P > 0 THEN 'get user specified drive, if any
      D$ = LEFT$(S$, P)
      S$ = MID$(S$, P + 1)
   END IF

   P = INSTR(S$, ".")
   IF P = 0 THEN P = LEN(S$) + 1
   IF P = 9 THEN MID$(S$, 8, 1) = "Q" ELSE S$ = LEFT$(S$, P - 1) + "Q" + MID$(S$, P)
   S$ = D$ + S$
END IF

IF BAD = 1 THEN
   COLOR CYAN, BLACK
   PRINT STRING$(24, 32);
   PRINT S$; " IS A BAD FILENAME"
   END
END IF

FIL$ = S$ + CHR$(0)

CALL EXIST(FIL$, FILEXISTS%)

IF FILEXISTS% THEN
   COLOR CYAN, BLACK
   PRINT STRING$(14, 32);
   PRINT S$; " ALREADY EXISTS";
   COLOR YELLOW, BLACK
   PRINT " CONTINUE ANYWAY? ";
GET.ANS:
   I$ = INPUT$(1)
   CALL UPCASE(I$)
   IF I$ = "N" THEN END
   IF I$ <> "Y" THEN GOTO GET.ANS
   KILL S$
END IF

'--------------------do the conversion----------------------
RECLEN = 16300

OPEN F$ FOR BINARY AS #1 LEN = RECLEN
OPEN S$ FOR BINARY AS #2 LEN = RECLEN

INSOUND$ = CHR$(&HE4) + CHR$(&H61)
SOUND$ = CHR$(&HE6) + CHR$(&H61)
KEYCLEAR$ = CHR$(&HC) + CHR$(&H80)
NOP$ = CHR$(&H90) + CHR$(&H90)

FILELEN = LOF(1)
NUMREC = INT(FILELEN / RECLEN)
FOR BYTE = 1 TO NUMREC

BYTE$ = INPUT$(RECLEN, 1)
BYTE$ = B$ + BYTE$
GOSUB CHECK.SOUND

NEXT BYTE

'----------get exact length of last record & finish up---------------

BYTE$ = INPUT$(FILELEN - RECLEN * NUMREC, 1)
BYTE$ = B$ + BYTE$

GOSUB CHECK.SOUND

PUT #2, , B$                         'write record (last 40 bytes)

CLOSE

LOCATE 24, 20

COLOR CYAN, BLACK

IF FOUND.NOISE = 1 THEN
	PRINT F$; " HAS BEEN SILENCED";
       
	ELSE PRINT "NO NOISEMAKERS FOUND IN "; F$;
	KILL S$

END IF

END

'==========================================================================
'                              SUBROUTINES
'==========================================================================

PARSE.COMMAND:
	P = INSTR(C$, " ")

	IF P = 0 THEN
	   F$ = C$
	   RETURN
	END IF

	F$ = LEFT$(C$, P - 1)

	S$ = MID$(C$, P + 1)
	CALL STRIPBLANKS(S$, 3, SLEN%)
	S$ = LEFT$(S$, SLEN%)

    'check for bad file name

	P = INSTR(S$, ":")
	IF (P > 0) AND (P <> 2) THEN BAD = 1
	Q = INSTR(S$, ".")
	IF (Q - P) > 9 THEN BAD = 1
	IF (Q > 0) AND (LEN(S$) - Q) > 3 THEN BAD = 1

	RETURN

'---------------------------------------------------------------------
CHECK.SOUND:
	P = INSTR(P + 1, BYTE$, INSOUND$)    'find status check of port 61H
	IF P = 0 THEN GOTO NO.SOUND          'can't be sound if not checked
	Q = INSTR(P, BYTE$, KEYCLEAR$)       'check if keyboard clear (OR AL, 80H)
	IF Q - P <= 10 THEN GOTO CHECK.SOUND 'skip if keyboard clear function

C.S:
	Q = INSTR(P, BYTE$, SOUND$)          'find sound out
	IF Q - P > 20 THEN GOTO CHECK.SOUND  'prob. not part of local code
	IF Q = 0 THEN GOTO CHECK.SOUND       'no more local sound
	MID$(BYTE$, Q, 2) = NOP$             'blank the sound out
	FOUND.NOISE = 1
	GOTO C.S                             'check for more local sound

NO.SOUND:                                    'all sound (if any) processed
	B$ = RIGHT$(BYTE$, 40)               'preserve right 40 bytes
	L = LEN(BYTE$) - 40                  'write all but
	BYTE$ = LEFT$(BYTE$, L)              '  the last 40 bytes
	PUT #2, , BYTE$                      'write record
	RETURN                               'and return

